import heat as ht
import numpy as np
import torch
import time
arrsize = 100000000
times = []
# warm-up
for _ in range(2):
    a = ht.ones(arrsize, dtype=ht.float32)#, split=0)
    b = ht.ones(arrsize, dtype=ht.float32)#, split=0)
    c = a*b + a**2 + b**2 + a-b

# Heat
for _ in range(10):
    a = ht.ones(arrsize, dtype=ht.float32)#, split=0)
    b = ht.ones(arrsize, dtype=ht.float32)#, split=0)
    t1 = time.perf_counter()
    #c = a**2
    #c = a**ht.array(2)
    #c = a*a
    #c = a*2
    #c = a+b
    #c = a+2
    #c = a*b + a**2 + b**2 + a-b
    c = a*b + a*a + b*b + a-b
    t2 = time.perf_counter()
    times.append(t2 - t1)
print("heat mean time: ", np.mean(times))

#NumPy
for _ in range(10):
    a = np.ones(arrsize, dtype=np.float32)
    b = np.ones(arrsize, dtype=np.float32)
    t1 = time.perf_counter()
    #c = a**2
    #c = a**np.array(2)
    #c = a*a
    #c = a*2
    #c = a+b
    #c = a+2
    #c = a*b + a**2 + b**2 + a-b
    c = a*b + a*a + b*b + a-b
    t2 = time.perf_counter()
    times.append(t2 - t1)
print("numpy mean time: ", np.mean(times))

# PyTorch
for _ in range(10):
    a = torch.ones(arrsize, dtype=torch.float32)
    b = torch.ones(arrsize, dtype=torch.float32)
    t1 = time.perf_counter()
    #c = a**2
    #c = a**torch.tensor(2)
    #c = a*a
    #c = a*2
    #c = a+b
    #c = a+2
    #c = a*b + a**2 + b**2 + a-b
    c = a*b + a*a + b*b + a-b
    t2 = time.perf_counter()
    times.append(t2 - t1)
print("torch mean time: ", np.mean(times))
